/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.estudiante;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import logica.Listas;
import logica.Search;
import orm.Curso;
import orm.Estudiante;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "EstudiantesServlet", urlPatterns = {"/EstudiantesServlet"})
public class EstudiantesServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        HttpSession session = request.getSession(false);
        if (session != null) {
            session.invalidate();
        }
        String selected = request.getParameter("cursoSelected");
        
        Curso curso;
        if (selected != null) {
            curso = Search.buscarCurso(Integer.parseInt(selected.split("-")[0]), selected.split("-")[1]);
        } else {
            Curso[] cursos = Search.buscarCursos();
            if (cursos != null) {
                curso = cursos[0];
            } else {
                curso = null;
            }
        }
        
        Estudiante[] estudiantes;
        if (curso != null) {
            estudiantes = Search.buscarEstudiantes(curso);
        } else {
            estudiantes = null;
        }
        
        String[] cursos = Listas.listaCursos();
        String[][] apoderados = Listas.listaApoderados();
        request.setAttribute("tablaEstudiantes", estudiantes);
        request.setAttribute("listaCursos", cursos);
        request.setAttribute("listaApoderados", apoderados);
        request.setAttribute("selected", selected);
        request.getRequestDispatcher("estudiantes.jsp").forward(request, response);
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
